# What is React?
React is a technology that is used to create web applications known as Single Page Applications (SPA). SPAs are different from traditional static web pages because they primarily leverage JavaScript to control the display and user events. Angular is another popular SPA technology.
Because of its simplicity, React is a JavaScript library and not a framework. React enables one-way data binding and enables us to respond to user events. Data binding is the term used to describe the interaction between something that is visually displayed on the screen and the underlying connected data structure (model). When changes to the underlying model (state) are made, the UI automatically re-renders to reflect these changes. In other words, React “reacts” to changes to the model and updates the UI. Angular supports two-way data binding, which means changes to the UI automatically update the model and vice-versa.

The basic building block in React is called a component. A component is similar to the class construct found in high level languages such as Java or C#. Components come in two flavors, class based and function based. Function components are the new modern style of components and class components are legacy components. It’s not clear when class based components will be officially depreciated but the handwriting is on the wall. New React projects should use function based components. Both Angular and React have components.

A React application consists of a tasteful blend of components that interact with each other. We should design our components so that they are small, clear and concise. A component should do one thing and one thing well. Much like a class, components have data and behavior. A component can have other child components. A component can pass data to it’s child component and a child component can call back to its parent component. The component is the primary building block of a React application.

Once you understand the zen of React components, you can use the same concepts to build native iOS or Android applications using a framework called React Native. React Native allows us to create React components in JavaScript which are converted to native mobile applications. React Native applications written in JavaScript can be deployed to Apple’s App Store and Google’s Play Store.
React applications are created using an NPM command. Since React applications are based in JavaScript we can leverage a plethora of libraries found in NPM. This enables us to quickly make our applications powerful and beautiful. By simply executing an NPM command we can create production ready React applications which can run on any web hosting technology that supports HTML and JavaScript. This entire website is a React application that resides in an AWS S3 bucket and costs fractions of a penny a month.

I prefer React over Angular because using React makes me a better JavaScript developer. When you know JavaScript you open yourself up to a wider range of projects and opportunities, such as backend API development. When you use Angular, you’ll get good at Angular HTML templates which are only good for Angular applications. I also prefer React because of the integration with NPM. If I need something in particular, there’s a good chance it already exists in NPM and I can simply import it into my project.

If you want to learn React, I strongly suggest you learn JavaScript first. Then I would learn some basic HTML and CSS. Once you have a good handle on these things you can start to dive deep into creating a single React component. Once you feel comfortable with all the things you can do with one single component you can start to create bigger components that contain child components. Before you know it, you’ll have a full blown React app.